; app.nsi
;
;
;--------------------------------

; The name of the installer
Name "${APPNAME} for Windows"

; The file to write
OutFile "..\${APPNAME}-${VER_DISPLAY}.win32.exe"
SetCompressor lzma

LoadLanguageFile "${NSISDIR}\Contrib\Language Files\English.nlf"

;--------------------------------
;Version Information

; Version information comes from the commandline

  VIProductVersion "${VER_DISPLAY}"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "ProductName" "${APPNAME}"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "Comments" "${APPDESCRIPTION}"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "CompanyName" "${COMPANYNAME}"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "LegalCopyright" "${COPYRIGHTINFO}"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "FileDescription" "${APPNAME}"
  VIAddVersionKey /LANG=${LANG_ENGLISH} "FileVersion" "${VER_DISPLAY}"

;--------------------------------
; Icon Stuff

Icon app.ico
UninstallIcon app.ico

Page license
Page directory
Page instfiles

WindowIcon on

; The default installation directory
InstallDir $PROGRAMFILES\${APPNAME}
LicenseData winCOPYING.txt
LicenseForceSelection radiobuttons "I Accept" "I Decline"

; The text to prompt the user to enter a directory
DirText "This will install ${APPNAME} on your computer. Please choose a directory"

;--------------------------------

Section license
SectionEnd

; The stuff to install
Section "Install" ;No components page, name is not important

  ; Set output path to the installation directory.
  SetOutPath $INSTDIR
  
  ; Put file there
    File /r resources
    File acme.exe
    File python24.dll
    File library.zip
    File MSVCR71.dll
    File w9xpopen.exe

    CreateShortCut "$SMPROGRAMS\${APPNAME}.lnk" "$INSTDIR\${APPNAME}.exe" "" ""
    CreateShortCut "$QUICKLAUNCH\${APPNAME}.lnk" "$INSTDIR\${APPNAME}.exe" "" ""
    
    WriteUninstaller $INSTDIR\Uninstall.exe
    WriteRegStr HKLM "Software\${APPNAME}" "" $INSTDIR
    WriteRegDword HKLM "Software\${APPNAME}" "VersionMajor" "${VER_MAJOR}"
    WriteRegDword HKLM "Software\${APPNAME}" "VersionMinor" "${VER_MINOR}"
    WriteRegDword HKLM "Software\${APPNAME}" "VersionRevision" "${VER_REVISION}"
    WriteRegDword HKLM "Software\${APPNAME}" "VersionBuild" "${VER_BUILD}"
    
    WriteRegExpandStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${APPNAME}" "UninstallString" '"$INSTDIR\Uninstall.exe"'
    WriteRegExpandStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${APPNAME}" "InstallLocation" "$INSTDIR"
    WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${APPNAME}" "DisplayName" "${APPNAME}"
    WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${APPNAME}" "DisplayIcon" "$INSTDIR\${APPNAME}.exe,0"
    WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${APPNAME}" "DisplayVersion" "${VER_DISPLAY}"
    WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${APPNAME}" "VersionMajor" "${VER_MAJOR}"
    WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${APPNAME}" "VersionMinor" "${VER_MINOR}.${VER_REVISION}"
    WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${APPNAME}" "URLInfoAbout" "http://www.armagetronad.net/"
    WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${APPNAME}" "NoModify" "1"
    WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${APPNAME}" "NoRepair" "1"

SectionEnd ; end the section

; Uninstaller

UninstallText "This will uninstall ${APPNAME}. Hit next to continue."

; Uninstall section

Section "Uninstall"
    ; remove files and uninstaller
    RMDir /r $INSTDIR
    
    
    ; remove shortcuts, if any
    Delete "$SMPROGRAMS\${APPNAME}.lnk"
    Delete "$QUICKLAUNCH\${APPNAME}.lnk"
    
    DeleteRegKey HKLM "Software\${APPNAME}"
    DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${APPNAME}"
    
SectionEnd
  

