#!/usr/bin/env python

'''

    @version $Id: __init__.py 7231 2007-05-20 22:53:21Z davidfancella $

    This file is part of acme.

    acme is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    acme is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with acme; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    acme is copyright 2005 by David Fancella

'''

import math

from libacme.mapobjects import base_element

class xSpawn(base_element.baseElement):
    objType = "spawn"
    x = None
    y = None
    angle = None
    xdir = None
    ydir = None
    theNode = None
    
    def __init__(self, theSpawn=None, theNode=None, **args):
        super(xSpawn, self).__init__(**args)
        
        if theSpawn is not None:
            self.theNode = theNode
            
            self.x = theSpawn['x']
            self.y = theSpawn['y']
            self.xdir = theSpawn['xdir']
            self.ydir = theSpawn['ydir']
            self.angle = theSpawn['angle']
            
            if self.angle == "":
                self.angle = math.degrees(math.atan2(self.ydir, self.xdir) )

