#!/usr/bin/env python

'''

    @version $Id: __init__.py 7231 2007-05-20 22:53:21Z davidfancella $

    This file is part of acme.

    acme is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    acme is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with acme; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    acme is copyright 2005, 2007 by David Fancella

'''

from libacme import paths

class Resource(object):
    theDom = None
    rAuthor = None
    rType = None
    rName = None
    rVersion = None
    rCategory = None
    
    thePath = None
    
    def __init__(self, theDom = None):
        if theDom is not None:
            self.LoadResourceFields(theDom)
            
        self.theDom = theDom
        
    # This method must not be implemented in base classes
    def SaveFile(self, thePath):
        theFile = open(thePath, "w")
        
        self.theDom.writexml(theFile)
        
    def GetDom(self):
        return self.theDom
        
    def GetType(self):
        return self.rType
        
    def GetName(self):
        return self.rName
        
    def LoadResourceFields(self, theDom):
        resourceNode = theDom.getElementsByTagName('Resource')[0]
        
        self.rAuthor = resourceNode.getAttribute("author")
        self.rType = resourceNode.getAttribute("type")
        self.rName = resourceNode.getAttribute("name")
        self.rVersion = resourceNode.getAttribute("version")
        self.rCategory = resourceNode.getAttribute("category")
        
        #print self.rAuthor, self.rType, self.rName, self.rVersion, self.rCategory

    def CopyResource(self, theResource):
        self.rAuthor = theResource.rAuthor
        self.rType = theResource.rType
        self.rName = theResource.rName
        self.rVersion = theResource.rVersion
        self.rCategory = theResource.rCategory

