#!/usr/bin/env python

'''

    @version $Id: __init__.py 7231 2007-05-20 22:53:21Z davidfancella $

    This file is part of acme.

    acme is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    acme is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with acme; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    acme is copyright 2005, 2007 by David Fancella

'''

import math

from PyQt4 import QtGui, QtCore

class Spawn(QtGui.QGraphicsItem):
    def __init__(self, spawnObj):
        #print type(parent)
        QtGui.QGraphicsItem.__init__(self)
        
        self.setFlags( QtGui.QGraphicsItem.ItemIsMovable or QtGui.QGraphicsItem.ItemIsSelectable)
        # Spawns are drawn near the top of the stack, they're very important
        self.setZValue(10)
        
        self.setPos(spawnObj.x, spawnObj.y )
        self.theSpawn = spawnObj
        self.rotate(self.theSpawn.angle)
        
    def paint(self, painter, option, widget):
        painter.setPen(QtCore.Qt.red);
        theBrush = QtGui.QBrush(QtCore.Qt.SolidPattern)
        theBrush.setColor(QtCore.Qt.red)
        painter.setBrush( theBrush )
        thePointList = QtGui.QPolygonF()
        
        points = [
                [ 8, 0 ],
                [ 0, -10 ],
                [0, -3],
                [-8, -3],
                [-8, 3],
                [0,3],
                [0,10],
                [8,0]
        ]
        
        for a in points:
            thePointList.append( QtCore.QPointF(a[0], a[1]) )
        painter.drawConvexPolygon(thePointList )
        
    def boundingRect(self):
        #print self.leftx, self.bottomy, self.rightx-self.leftx, self.topy-self.bottomy
        return QtCore.QRectF( -10, -10, 20, 20 )

