#!/usr/bin/env python

'''

    @version $Id: __init__.py 7231 2007-05-20 22:53:21Z davidfancella $

    This file is part of acme.

    acme is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    acme is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with acme; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    acme is copyright 2005, 2007 by David Fancella

'''

from PyQt4 import QtGui, QtCore

class Zone(QtGui.QGraphicsItem):
    def __init__(self, zoneObj):
        #print type(parent)
        QtGui.QGraphicsItem.__init__(self)
        
        self.setFlags( QtGui.QGraphicsItem.ItemIsMovable or QtGui.QGraphicsItem.ItemIsSelectable)
        # Zones are drawn at the top
        self.setZValue(5)
        
        self.setPos(zoneObj.x, zoneObj.y )
        self.theZone = zoneObj
        
    def paint(self, painter, option, widget):
        frontPen = QtGui.QPen(QtCore.Qt.DashLine)
        frontPen.setWidth(1)

        if self.theZone.effect == "fortress":
            frontPen.setColor(QtCore.Qt.green)
        else:
            frontPen.setColor(QtCore.Qt.red)
        
        frontPen.setDashPattern( [6, 9] )
        
        painter.setPen(frontPen)
        theRect = QtCore.QRectF( -self.theZone.radius, -self.theZone.radius, self.theZone.radius*2, self.theZone.radius*2 )
        
        painter.drawEllipse(theRect)
        
    def boundingRect(self):
        #print self.leftx, self.bottomy, self.rightx-self.leftx, self.topy-self.bottomy
        return QtCore.QRectF( -self.theZone.radius-5, -self.theZone.radius-5, self.theZone.radius*2+10, self.theZone.radius*2+10 )

