#!/usr/bin/env python

'''

    @version $Id: __init__.py 7231 2007-05-20 22:53:21Z davidfancella $

    This file is part of acme.

    acme is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    acme is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with acme; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    acme is copyright 2005, 2007 by David Fancella

'''

from PyQt4 import QtGui, QtCore

from libacme import paths

class ToolBook(QtGui.QTabWidget):
    
    def __init__(self, parent):
        QtGui.QTabWidget.__init__(self, parent)
        
        self.closeTab = QtGui.QToolButton(self)
        self.closeTab.setIcon( QtGui.QIcon( QtGui.QPixmap( paths.GetPath('icons', 'close_button.png') ) ) )
        
        self.setCornerWidget(self.closeTab, QtCore.Qt.BottomLeftCorner)
        self.setTabPosition(QtGui.QTabWidget.South)
        #self.setContentsMargin(0,0,0,0)
        
        self._connectSlots()

    def _connectSlots(self):
        QtCore.QObject.connect(self.closeTab, QtCore.SIGNAL("clicked(bool)"), self.closeTabClick)
        QtCore.QObject.connect(self, QtCore.SIGNAL("currentChanged(int)"), self.editorChanged)

    def closeTabClick(self, status):
        self.emit( QtCore.SIGNAL("editorClose"), self.currentWidget() )
        
    def editorChanged(self, index):
        self.emit( QtCore.SIGNAL("editorSelected"), self.widget(index) )









