#!/usr/bin/env python

'''

    @version $Id: setup.py 4607 2006-05-28 06:29:43Z luke-jr $

    This file is part of acme.

    acme is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    acme is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with acme; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	acme is copyright 2005 by David Fancella

'''

from distutils.core import setup
import shutil
import sys,os
if sys.platform == 'win32':
    import py2exe
    os.environ['PATH'] += ";c:\\Program Files\\NSIS\\"
    nsispath = ""

paname="acme"
companyname="acme"
paversion="0.1.0"
copyrightinfo="(C)opyright 2005 by Dave Fancella"
pabuild = "0"
paauthor="Dave Fancella"
paauthor_email="dave@davefancella.com"
pamaintainer="Dave Fancella"
pamaintainer_email="dave@davefancella.com"
paurl="http://www.armagetronad.net/"
paDescription = '''ACME is the Armagetron Advanced Map Editor'''
paLongDescription = '''ACME is the Armagetron Advanced Map Editor'''
papackages=[]

scriptsI = ['acme']

datafiles = []

def CallSetup(opts = None, thiswindows = None):
    if thiswindows == None:
        setup(name=paname,
              version=paversion,
              author=paauthor,
              author_email=paauthor_email,
              maintainer=pamaintainer,
              maintainer_email=pamaintainer_email,
              url=paurl,
              description=paDescription,
              long_description=paLongDescription,
              packages=papackages,
              windows=scriptsI,
              data_files=datafiles
             )
    else:
        setup(name=paname,
              version=paversion,
              author=paauthor,
              author_email=paauthor_email,
              maintainer=pamaintainer,
              maintainer_email=pamaintainer_email,
              url=paurl,
              description=paDescription,
              long_description=paLongDescription,
              packages=papackages,
              scripts=scriptsI,
              options=opts,
              console=thiswindows,
              data_files=datafiles
             )


def MakeNSIS(nsversion):
    print "Copying NSIS file to dist directory"
    shutil.copy('internal\\win\\app.nsi', 'dist')
    print "Copying license file to dist directory"
    shutil.copy('internal\\win\\winCOPYING.txt', 'dist')
    print "Copying icon file to dist directory"
    shutil.copy('internal\\win\\app.ico','dist')
    print "Done!"
    nsisbase = nsispath + 'makensis'
    os.chdir("dist")
    
    nsisbase += ' /D' + "VER_MAJOR=" + nsversion[0]
    nsisbase += ' /D' + "VER_MINOR=" + nsversion[1]
    nsisbase += ' /D' + "VER_REVISION=" + nsversion[2]
    nsisbase += ' /D' + "VER_BUILD=" + nsversion[3]
    nsisbase += ' /D' + "VER_FILE=" + nsversion[0] + '.' + nsversion[1] + '.' + nsversion[2] + '.'
    nsisbase += ' /D' + "VER_DISPLAY=" + nsversion[0] + '.' + nsversion[1] + '.' + nsversion[2] + '.' + nsversion[3]
    nsisbase += ' /D' + "APPNAME=" + paname
    nsisbase += ' /D' + "COMPANYNAME=" + companyname
    nsisbase += ' /D' + "APPDESCRIPTION=\"" + paDescription + "\""
    nsisbase += ' /D' + "COPYRIGHTINFO=\"" + copyrightinfo + "\""
    
    nsisbase += ' app.nsi'
    
    print "Running " + nsisbase
    mkfp = os.system(nsisbase)
    '''for line in mkfp:
        print line
        
    mkfp.close()'''
    print "Done!"
    
if sys.platform=="win32":
    callpy2exe = False
    nsisversion = paversion.split('.')
    nsisversion.append(pabuild)
    for check in sys.argv:
        if check == 'py2exe':
            callpy2exe = True
            opts = { "py2exe": {
                    "includes" : 'pygame.locals,libGUIacme,libacme'
                }
            }
            windows = [ {
                "script": "acme",
                "icon_resources" : [(1,"internal/win/app.ico")]
                }
            ]
            datafiles =[('resources/graphics', ['resources/graphics/rim_wall.png']),
                 ('resources/fonts', ['resources/fonts/Imperium.ttf']),
                 ('resources/dtd', ['resources/dtd/map-0.1-exp.dtd',
                                    'resources/dtd/map-0.1.dtd']),
                 ('resources/icons', ['resources/icons/armagetronad.png',
                                      'resources/icons/editcut.png',
                                      'resources/icons/filesave.png',
                                      'resources/icons/filesaveas.png',
                                      'resources/icons/spawn.png',
                                      'resources/icons/walls.png'])
                  ]
            papackages = ['libacme', 'libGUIacme', 'libGUIacme.widgets']
        if check == 'makensis':
            MakeNSIS(nsisversion)
            sys.exit(0)
    if callpy2exe is True:
        CallSetup(opts, windows)
    #print
    #print "Copying icon to dist directory"
    #shutil.copy('win\\app.ico','dist\\acmeRun')
    MakeNSIS(nsisversion)
    
else:
    datafiles = [('share/acme/resources/graphics', ['resources/graphics/rim_wall.png']),
                 ('share/acme/resources/fonts', ['resources/fonts/Imperium.ttf']),
                 ('share/acme/resources/dtd', ['resources/dtd/map-0.1-exp.dtd',
                                    'resources/dtd/map-0.1.dtd']),
                 ('share/acme/resources/icons', ['resources/icons/armagetronad.png',
                                      'resources/icons/editcut.png',
                                      'resources/icons/filesave.png',
                                      'resources/icons/filesaveas.png',
                                      'resources/icons/spawn.png',
                                      'resources/icons/walls.png'])
                  ]
    #datafiles.append( ('lib/menu', ['Graphics/acme']) )
    CallSetup()
    
    
    

     
     